!
! Matmul sample program
! written by Carlo Cavazzoni - CINECA - Feb 2003
! send any comments to
! c.cavazzoni@cineca.it
!

      PROGRAM test_dgemm

      IMPLICIT NONE

      INTEGER, PARAMETER :: dim = 1000
      REAL*8, ALLOCATABLE :: x(:,:), y(:,:), z(:,:)
      INTEGER :: i,j,k
      REAL*8 :: t1, t2
      REAL*8 :: cclock
      EXTERNAL :: cclock


      ALLOCATE( x( dim, dim ), y( dim, dim ), z( dim, dim ) )

      y = 1.0d0
      z = 1.0d0 / DBLE( dim )
      x = 0.0d0

      t1 = cclock()

      ! x = matmul( y, z )
      call dgemm('N', 'N', dim, dim, dim, 1.0d0, y, dim, z, dim, &
                0.0d0, x, dim)

      t2 = cclock()

      write(*,*) ' Matrix sum = ', sum(x)
      write(*,*) ' tempo (secondi) ', t2-t1
      DEALLOCATE( x, y, z )

      END PROGRAM
