!
! Matmul sample program
! written by Carlo Cavazzoni - CINECA - Feb 2003
! send any comments to
! c.cavazzoni@cineca.it
!

      PROGRAM test_dgemm

      IMPLICIT NONE

      INTEGER, PARAMETER :: dim = 2000
      COMPLEX*16, ALLOCATABLE :: x(:), y(:)
      INTEGER :: i,j,k
      REAL*8 :: t1, t2
      REAL*8 :: cclock
      EXTERNAL :: cclock
      EXTERNAL :: zdotu
      COMPLEX*16 :: zdotu, z


      ALLOCATE( x( dim * dim ), y( dim * dim ))

      y = 1.0d0 / DBLE( dim )
      x = 1.0d0 / DBLE( dim )

      t1 = cclock()

      z = zdotu( dim*dim, x, 1, y, 1 )

      t2 = cclock()

      write(*,*) ' sum = ', z
      write(*,*) ' tempo (secondi) ', t2-t1
      DEALLOCATE( x, y )

      END PROGRAM
